{-
	Copyright (C) 2010 Dr. Alistair Ward

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
-}
{- |
 [@AUTHOR@]	Dr. Alistair Ward

 [@DESCRIPTION@]	Miscellaneous operations on Pairs.
-}

module ToolShed.Pair(
-- * Functions
	mirror,
-- ** Predicates
	both,
	neither
) where

import	Control.Arrow((***))

-- | Apply the same transformation to both halves of a /Pair/.
mirror :: (a -> b) -> (a, a) -> (b, b)
mirror f	= f *** f

-- | 'True' if both halves of the /Pair/ are.
both :: (Bool, Bool) -> Bool
both	= uncurry (&&)

-- | 'True' if neither half of the /Pair/ is.
neither :: (Bool, Bool) -> Bool
neither	= not . uncurry (||)

